<?php

/*
 * Written By Mickaël B. : http://mickaelbertrand.imagika.fr/
 * Twitter : http://twitter.com/mbimagika
 * 
 */


$url = (isset($_REQUEST['url'])) ? $_REQUEST['url'] : '';
$monurl = (isset($_REQUEST['monurl'])) ? $_REQUEST['monurl'] : '';
$ancre = (isset($_REQUEST['ancre'])) ? $_REQUEST['ancre'] : '';

if(!empty($url)) {
	$msg = "Le backlink n'a pas l'air d'être indéxé pour le moment... Ou il n'a pas encore été inséré dans la page <a href=\"".getGgQuery($url,$ancre)."\">Vérifier manuellement</a>";

	if(!empty($_REQUEST['submit1']) && isPageIndexed($url,$ancre) == true) {
		$msg = 'Votre backlink semble indéxée : <a href="'.getGgQuery($url,$ancre).'">Vérifier manuellement</a>';
	} else if (!empty($_REQUEST['submit2'])) {
		if(isPageIndexed($url,$ancre) !== false) {
			$res = isCached($url,$ancre,$monurl);
			if(is_array($res)) {
				$msg = '<ul>
							<li>Rel : <strong>'.$res['rel'].'</strong></li>
							<li>Avec pour ancre : <strong>'.$res['ancre']['text'].'</strong> (Type : '.$res['ancre']['type'].')</strong></li>
							<li>Et pour position dans la page : <strong>'.$res['pos'].' sur '.$res['total'].'</strong> (car. HTML compris)</li>';
				$msg .= '<li>Ce site link également : '
					.'(<a href="#other-links" onclick="document.getElementById(\'other-links\').style.display=\'block\';">Voir tout</a> - '
					.'<a href="#other-links" onclick="javascript:document.getElementById(\'other-links\').style.display=\'none\';">Cacher tout</a>)'
					.'<table id="other-links">';
				foreach($res['links'] as $l) {
					$msg .= '<tr><td>'.$l['href'].'</td><td>'.$l['ancre']['text'].' ('.$l['ancre']['type'].')</td></tr>';
				}
				$msg .= '</table></li></ul>';
			} else {
				$msg = $res;
			} 
		}
	}
}

?>
<html>
<head>
<title>Check Index of Google</title>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<style type="text/css">
*{ margin:0; padding:0; font-family:Tahoma, sans-serif;text-align:left;}
body{background:#d5e5ff;}
h1{color:#444;}
p, div.p{margin:20px 10px;}
ul{padding-left:40px;margin:10px 0;}
label{width:150px;float:left;}
#other-links {display:none;}
</style>

</head>
<body style="background:#efefef;">
<div style="width:800px;margin:0 auto;background:#fff;padding:20px;">
	<h1>Backlink Check</h1>
	<div style="background:#def;text-align:center;padding:3px;"><?php echo $msg; ?></div>
	<form>
		<p><label>URL Backlink</label><input type="text" name="url" value="<?php echo $url; ?>" /></p>
		<p style="text-align:right;color:#444;">ex : http://www.lesite.com/lapage.html ou http://lesite.com/lapage/, etc...</p>
		<p><label>Mon URL</label><input type="text" name="monurl" value="<?php echo $monurl; ?>" /></p>
		<p style="text-align:right;color:#444;">ex : http://www.monsite.com/ ou http://monsite.com/mapage.html, etc...</p>
		<p><label>Ancre</label><input type="text" name="ancre" value="<?php echo $ancre; ?>" /></p>
		<div style="width:400px;margin:0 auto;">
			<input type="submit" value="Check Google SERP" name="submit1" />
			<input type="submit" value="Check Google Cache" name="submit2" />
		</div>
	</form>
	<div>
		<p><strong>Check Google SERP</strong> : Va controler si l'ancre est présente sur la page indiquée 
		et si celle-ci est indéxée par Google <br />>> <u>Rend obligatoire le champ Ancre</u></p>
		<p><strong>Check Google Cache</strong> : Va controler si le lien est bien dans la page qui est dans 
		le cache de Google (retourne l'ancre (avec type (alt/texte)), le rel (do/nofollow) et la position dans 
		la page, ainsi que tous les autres liens "en dur html" de la page) <br />>> <u>Rend obligatoire le champs URL</u></p>
	</div>
	<div>
		Attention : 
		<ul>
			<li>Ne gère pas avec et sans les www automatiquement, les url indiquées doivent donc être correctes.</li>
		</ul>
	</div>
</div>
</body>
</html>

<?php
	function isCached($url, $ancre='', $monurl='') {
		$file = file(getGgQuery($url,$ancre));
		
		$html = '';
		foreach($file as $line) {
			$html .= $line;
		}
		
		//on récupère l'adresse du cache de la page où il est censé y avoir le backlink
		preg_match_all("|<span class=gl><a href=\"(.*)\">|U",
							$html, $tab, PREG_SET_ORDER);
		
		//la page n'est pas en cache
		if(empty($tab)) { return "Cette page ne semble pas être en cache"; }
		//si l'utilisateur n'a pas spécifié de lien (celui vers lequel doit pointer le BL) alors impossible de check
		if(empty($monurl)) { return "La page est en cache, mais vous n'avez pas spécifiez l'url cible du lien"; }
		
		// on va récupérer le contenu du cache
		$infos = array();
		$infos['cache_url'] = $tab['0']['1'];
			
		$file = file($tab['0']['1']);
			
		$html = '';
		foreach($file as $line) {
			$html .= $line;
		}
	
		//on récupère tous les liens de la page
		preg_match_all("|<a(.*)</a>|U", $html, $links, PREG_SET_ORDER);
			
		$infos['total'] = strlen($html);
		$infos['rel'] = 'DoFollow (par défaut)';
		$infos['links']=array();
		foreach($links as $link) {
			if(strpos($link['0'], 'href="'.getUrlSlash($monurl).'"') !== false
				|| strpos($link['0'], 'href="'.getUrlSlash($monurl,false).'"') !== false) {
				if(strpos($link['0'], 'nofollow')) {
					$infos['rel'] = 'nofollow';
				} else if(strpos($link['0'], 'dofollow')) {
					$infos['rel'] = 'dofollow';
				}
				$infos['ancre'] = getAncre($link['0']);
				$infos['pos'] = strpos($html,$link['0']);
			} else {
				$pos = strpos($link['0'],'href="');
				$infos['links'][] = array('link'=>$link['0'],'ancre'=>getAncre($link['0'])
											,'href'=>substr($link['0'],$pos+6,strpos($link['0'],'"',$pos+7)-$pos-6));
			}
			continue;
		}
		if(!empty($infos['pos'])) {
			return $infos;
		}
			
		return 'Le lien n\'est pas présent sur la page qui est en cache de Google. <a href="'.$infos['cache_url'].'">Vérifier manuellement</a>';
	}//isCached
	
	function getAncre($link) {
		if(strpos($link, '<img')) {
			preg_match("|<img[^>]+alt=\"(.*)\"|U",
						$link, $ancre['ancre']['text'], PREG_OFFSET_CAPTURE);
			$ancre['text'] = $ancre['ancre']['text']['1']['0'];
			$ancre['type'] = 'alt sur balise img';
		} else {
			$ancre['text'] = strip_tags($link);
			$ancre['type'] = 'texte';
		}
		return $ancre;
	}//getAncre

	function getGgQuery($url, $ancre='') {
		if(!empty($ancre)) {
			return 'http://www.google.fr/search?q='.urlencode('site:'.$url.' "'.$ancre.'"');
		} else {
			return 'http://www.google.fr/search?q='.urlencode('site:'.$url);
		}
	}//getGgQuery
	
	function isPageIndexed($url,$ancre='') {
		$file = file(getGgQuery($url,$ancre));
		
		$html = '';
		foreach($file as $line) {
			$html .= $line;
		}
		
		preg_match_all("|<h3 class=\"r\">(.*)</h3>|U",
							$html, $tab, PREG_SET_ORDER);
							
		for($i=0,$sz=count($tab); $i<$sz ; ++$i) {
			$first_pos = strpos($tab[$i]['0'],'<a href="'.getUrlSlash($url).'"');
			if($first_pos === false) {
				if(strpos($tab[$i]['0'],'<a href="'.getUrlSlash($url,false).'"') === false) { continue; }
			}
			return true;
		}
		return false;
	}//isPageIndexed
	
	function getUrlSlash($url,$without = true) {
		if($without == true && stripos($url,'/') === 0) {
			return substr($url,0,strlen($url)-1);
		} else if($without == false && stripos($url,'/') !== 0) {
			return $url.'/';
		}
		return $url;
	}//getUrlWithoutSlash
?>
